//RadioProbe
//Copyright © 2000-2001, Paul Yu

#include "RadioProbeLink.h"
#include "RadioProbeConstants.h"
#include <Looper.h>
#include <Window.h>
#include <Font.h>
#include <Message.h>
#include <Application.h>
#include <Roster.h>

RadioProbeLink::RadioProbeLink(BLooper *looper)
	: BView(BRect(7, 54, 75, 64), "link", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_PULSE_NEEDED)
{
	mLooper = looper;
	mLinkDisabled = false;
	BFont font(be_plain_font);
	font.SetSize(10);
	ResizeTo(font.StringWidth(LISTEN kListenLink), 12);

	rgb_color linkcolor = { kLinkColor };

	for(int i = 0; i < 32; i++)
		memcpy(&mLinkColors[i], &linkcolor, sizeof(rgb_color));
}

void RadioProbeLink::AttachedToWindow()
{
	SetFont(be_plain_font);
	SetFontSize(10);
}

void RadioProbeLink::Draw(BRect updateRect)
{
	DrawString(LISTEN, BPoint(0,9));
	
	PushState();
	
	if (!mLinkDisabled)
		SetHighColor(mLinkColors[current_workspace()]);

	DrawString(kListenLink);
	
	PopState();
}

void RadioProbeLink::MouseDown(BPoint where)
{
	if (mLinkDisabled)
		return;

	mLinkDisabled = true;
	mLooper->PostMessage(P_LAUNCH_PLAYLIST);
	Window()->SetPulseRate(5000000);
	Invalidate();
}

void RadioProbeLink::Pulse()
{
	mLinkDisabled = false;
	Window()->SetPulseRate(0);
	Invalidate();
}

void RadioProbeLink::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case B_PASTE:
		{
			rgb_color *rgb;
			ssize_t size;
	
			if (msg->FindData("RGBColor", 'RGBC', (const void **)&rgb, &size) == B_OK)
			{
				memcpy(&mLinkColors[current_workspace()], rgb, sizeof(rgb_color));
				Invalidate();
			}
		}
		break;

		default:
			BView::MessageReceived(msg);
	}
}

