//RadioProbe
//Copyright © 2000-2001, Paul Yu

#include <View.h>
#include <String.h>
#include <Message.h>

class BMessageRunner;
class BBitmap;
class BLooper;
class RadioProbeLink;
class BPopUpMenu;
class BMenuField;

_EXPORT class RadioProbeView : public BView
{
	public:
		RadioProbeView(BRect frame);
		RadioProbeView(BMessage *archive);
		~RadioProbeView();

		status_t Archive(BMessage *into, bool deep = true) const;
		static	BArchivable	*Instantiate(BMessage *from);
	
		void AttachedToWindow();
		void Draw(BRect updateRect);
		void FrameResized(float width, float height);
		void MouseDown(BPoint where);
		void MessageReceived(BMessage *msg);
		void SetColors();

	protected:
		void Init();
		BString mTitle, mArtist;
		BMessage mMessage;
		BMessageRunner *mRunner;
		BLooper *mLooper;
		BBitmap *mBitmap;
		BMessage mProxyInfo;
		BPopUpMenu *mStream;
		BMenuField *mMenufield;
		RadioProbeLink *mLink;
		rgb_color mWSColors[32][2];
		int32 mPrevWorkspace;
		bool mPaused;
};
